/*
 * Copyright (c) 1983 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

char copyright[] =
  "@(#) Copyright (c) 1983 Regents of the University of California.\n"
  "All rights reserved.\n";

/*
 * From: @(#)main.c	5.10 (Berkeley) 3/1/91
 */
char main_rcsid[] = 
  "$Id: tftpmain.c,v 1.2 1999/07/21 22:55:58 dig Exp $";

/* Many bug fixes are from Jim Guyton <guyton@rand-unix> */

/*
 * TFTP User Program -- Command Interface.
 */
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/file.h>

#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>

#include <signal.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <setjmp.h>
#include <string.h>
#include <ctype.h>
#include <netdb.h>
#include <unistd.h>

#define	TIMEOUT		5		/* secs between rexmt's */

struct sockaddr_in s_inn;
int f;
int trace;
int verbose;
int rexmtval = TIMEOUT;
int maxtimeout = 5 * TIMEOUT;
void recvfile(int fd, char *name, char *modestr);


static int connected;
static short port;
static char mode[32];
static struct servent *sp;

void setpeer(char *);
void get(char *, char *);

void
wyse_tftp(char *server, char *src, char *dst)
{
    struct sockaddr_in s_in;

    sp = getservbyname("tftp", "udp");
    if (sp == 0)
	return;
    f = socket(AF_INET, SOCK_DGRAM, 0);
    if (f < 0)
	return;
    memset(&s_in, 0, sizeof(s_in));
    s_in.sin_family = AF_INET;
    if (bind(f, (struct sockaddr *)&s_in, sizeof (s_in)) < 0)
	return;
    strcpy(mode, "netascii");
    setpeer(server);
    if (connected)
	get(src, dst);
}

static char hostname[100];

void
setpeer(char *server)
{
    struct hostent *host;

    host = gethostbyname(server);
    if (host) {
	s_inn.sin_family = host->h_addrtype;
	if (host->h_length > (int)sizeof(s_inn.sin_addr))
	    host->h_length = sizeof(s_inn.sin_addr);
	memcpy(&s_inn.sin_addr, host->h_addr, host->h_length);
	strncpy(hostname, host->h_name, sizeof(hostname));
	hostname[sizeof(hostname)-1] = 0;
    } else {
	s_inn.sin_family = AF_INET;
	if (!inet_aton(server, &s_inn.sin_addr)) {
	    connected = 0;
	    return;
	}
	strcpy(hostname, server);
    }
    port = sp->s_port;
    connected = 1;
}


/*
 * Receive file(s).
 */
void
get(char *src, char *dst)
{
    int fd;

    fd = creat(dst, 0644);
    if (fd < 0)
	    return;
    s_inn.sin_port = port;
    recvfile(fd, src, mode);
}
