
#include "debugger.h"

#define fetch(p) (*(uint *) (p))

extern char 		*sysnames[];

/****************************************************************************

	DEBUGGER - Back Trace

****************************************************************************/

pidtoproc(pid)
{
	return(pid);
}

btcmd()
{
	register struct tss386 *ts;	

	if(getaddr(1)) {
		if (experr)
			return(-1);
		btrace(dbr0ptr[EBP], 0);
		return(0);
#if 0
		int	ebp, ofst, pid, found, exitted, i;
		btrace(p->p_qsav[3], 0);
		ts = p->p_userp->u_tss;
		ofst = (int) p->p_userp - (int) &u;
		ts = (struct tss386 *) (((int) ts) + ofst);
		du = (user_t *) p->p_userp;
		ofst = (int) du - (int) &u;
		btrace(ts->t_ebp, ofst); 
#endif
	} else  {
		btrace(dbr0ptr[EBP], 0);
	}
	return(0);
}

/*
 *	Some of the debugger functions stays even if debugger is not defined
*/

btrace(link, ofst)
	uint	link, ofst;
{
	register uint	rtn, p;
	register uint	calladr;
	uint		stktop;
	int		cnt = 256, i;
	int		*regframe;
	uint		savp;
	uchar		sm;
	extern	 int	imm_val, jmp_loc;
	extern 	 char	*reg_name;
	extern	 char	mneu[];
	extern	 int	etext;
	extern	 char	kdbintr;
	extern	 char	kdbtrap;

	stktop = (link + 4096) & ~(4096-1);
	do {
		p = link; calladr = -1;
		link = fetch(p+ofst); p += 4;
		rtn = fetch(p+ofst);  savp = p + 4;
		if (!valid_eip(rtn))
			break;
		calladr = findcaller(rtn);
		strcpy(mneu, spntadr(calladr));
		strcat(mneu, ": ");
		printf("%-18s", mneu);
		if (calladr == rtn)
			printf("call     ???(");
		else {
			dis_dot(calladr);
			printf("%s(", mneu);
		}
		i = rtn;
		for( ;; ) {
			jmp_loc = -1;
			imm_val = 0;
			reg_name = "";
			dis_dot(i);
			if (strncmp("jmp", mneu, 3) == 0 && jmp_loc != i) 
				i = jmp_loc;
			else
				break;
		}
		if (strncmp("popl", mneu, 4) == 0)
			imm_val = 4;
		else
		if (strncmp("addl", mneu, 4) ||
		    strncmp("%esp", reg_name, 4)) 
			imm_val = 16;
		while(imm_val > 0) {
			p += 4;
			i = fetch(p+ofst);
			printf("0x%x", i);
			imm_val -= 4;
			if (imm_val > 0)
				printf(", ");
		}
		printf(")\n");

		/*
		** check to see if at start of interrupt or trap stack frame
		**
		** kdbintr is defined in cmnint(intr.s)
		** kdbtrap is defined in cmntrap(ttrap.s)
		*/
frame:
		rtn = regframe[EIP];
		strcpy(mneu, spntadr(rtn));
		strcat(mneu, ": ");
		if (i == -1) {
			printf("%-18sTRAP(reg frame=0x%x)\n", 
					mneu, regframe);
		} else {
			printf("%-18sINTERRUPT(spl%d, reg frame=0x%x)\n", 
					mneu, i, regframe);
		}
		if (!valid_eip(rtn)) {
			printf("invalid eip register = 0x%x\n",rtn);
			break;
		}

		/*
		** continue stack trace
		*/
		link = regframe[EBP];
	} while(--cnt > 0 && link > p && link < stktop);
}

valid_eip(rtn)
	uint rtn;
{
	extern	int	_stext();
	extern	int	_etext();

	if (rtn >= (uint) _stext && rtn < (uint) _etext)
		return(1);
	return(0);
}

findcaller(rtn)
	uchar	*rtn;
{
	if (rtn[-5] == 0xE8)
		return((int) rtn - 5);
	if (rtn[-6] == 0xFF)
		return((int) rtn - 6);
	return((int) rtn);
} 
