
#include "debugger.h"

char	enames[155][10] = {
"UNUSED",
"EPERM",
"ENOENT",
"ESRCH",
"EINTR",
"EIO",
"ENXIO",
"E2BIG",
"ENOEXEC",
"EBADF",
"ECHILD",
"EAGAIN",
"ENOMEM",
"EACCES",
"EFAULT",
"ENOTBLK",
"EBUSY",
"EEXIST",
"EXDEV",
"ENODEV",
"ENOTDIR",
"EISDIR",
"EINVAL",
"ENFILE",
"EMFILE",
"ENOTTY",
"ETXTBSY",
"EFBIG",
"ENOSPC",
"ESPIPE",
"EROFS",
"EMLINK",
"EPIPE",
"EDOM",
"ERANGE",
"ENOMSG",
"EIDRM",
"ECHRNG",
"EL2NSYNC",
"EL3HLT",
"EL3RST",
"ELNRNG",
"EUNATCH",
"ENOCSI	",
"EL2HLT",
"EDEADLK",
"ENOLCK",
"UNUSED",
"UNUSED",
"UNUSED",
"EBADE",
"EBADR",
"EXFULL",
"ENOANO",
"EBADRQC",
"EBADSLT",
"EDEADLOCK",
"EBFONT",
"UNUSED",
"UNUSED",
"ENOSTR",
"ENODATA",
"ETIME",
"ENOSR",
"ENONET",
"ENOPKG",
"EREMOTE",
"ENOLINK",
"EADV",
"ESRMNT",
"ECOMM",
"EPROTO",
"UNUSED",
"UNUSED",
"EMULTIHOP",
"UNUSED",
"UNUSED",
"EBADMSG",
"ENAMETOOL",
"EOVERFLOW",
"ENOTUNIQ",
"EBADFD",
"EREMCHG",
"ELIBACC",
"ELIBBAD",
"ELIBSCN",
"ELIBMAX",
"ELIBEXEC",
"EILSEQ",
"ENOSYS",
"ELOOP",
"ERESTART",
"ESTRPIPE",
"ENOTEMPTY",
"EUSERS",
"ENOTSOCK",
"EDESTADDR",
"EMSGSIZE",
"EPROTOTYP",
"ENOPROTOO",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"UNUSED",
"EPROTONOS",
"ESOCKTNOS",
"EOPNOTSUP",
"EPFNOSUPP",
"EAFNOSUPP",
"EADDRINUS",
"EADDRNOTA",
"ENETDOWN",
"ENETUNREA",
"ENETRESET",
"ECONNABOR",
"ECONNRESE",
"ENOBUFS",
"EISCONN",
"ENOTCONN",
"Unused",
"Unused",
"Unused",
"Unused",
"Unused",
"Unused",
"Unused",
"Unused",
"ESHUTDOWN",
"ETOOMANYR",
"ETIMEDOUT",
"ECONNREFU",
"EHOSTDOWN",
"EHOSTUNRE",
"EALREADY",
"EINPROGRE",
"ESTALE"};


/*	Print a summary of the number of procs running, sleeping, and runable. */

procsummary()
{
#if 0
	register struct proc *rp;
	int runable, running, sleeping, zomb, idle, stopped, xbrk;
	uint  stat;
	int procsfound;

	runable = running = sleeping = zomb = idle = stopped = xbrk = 0;
	procsfound = 0;
	for (rp = &proc[0]; rp < (struct proc *)v.ve_proc; rp++) {
		stat = rp->p_stat;
		switch (stat) {
		case SRUN:
			runable++;
			procsfound++;
			break;
		case SONPROC:
			running++;
			procsfound++;
			break;
		case SSLEEP:
			sleeping++;
			procsfound++;
			break;
		case SZOMB:
			zomb++;
			procsfound++;
			break;
		case SSTOP:
			stopped++;
			procsfound++;
			break;
		case SIDL:
			idle++;
			procsfound++;
			break;
		case SXBRK:
			xbrk++;
			procsfound++;
			break;
		}
	}
	printf(" %d procs found\n", procsfound);
	printf("    %d procs executing\n", running);
	printf("    %d procs runable\n", runable);
	printf("    %d procs sleeping\n", sleeping);
	printf("    %d procs zombie\n", zomb);
	printf("    %d procs stopped\n", stopped);
	printf("    %d procs idle\n", idle);
	printf("    %d procs xbrk\n", xbrk);
#endif
}

/*	Print the status of proc p as a text string
 */
ppstat(p)
struct proc *p;
{
#if 0
	switch (p->p_stat) {
	case SSLEEP:
		printf("[SSLEEP] ");
		break;
	case SRUN:
		printf("[SRUN] ");
		break;
	case SZOMB:
		printf("[SZOMB] ");
		break;
	case SSTOP:
		printf("[SSTOP] ");
		break;
	case SIDL:
		printf("[SSIDL] ");
		break;
	case SONPROC:
		printf("[SONPROC] ");
		break;
	case SXBRK:
		printf("[SXBRK] ");
		break;
	}
#endif
}

/*	Print the status of proc p as a text string to the trace buffer.
 */
dppstat(p)
struct proc *p;
{
#if 0

	switch (p->p_stat) {
	case SSLEEP:
		dprintf("[SSLEEP] ");
		break;
	case SRUN:
		dprintf("[SRUN] ");
		break;
	case SZOMB:
		dprintf("[SZOMB] ");
		break;
	case SSTOP:
		dprintf("[SSTOP] ");
		break;
	case SIDL:
		dprintf("[SSIDL] ");
		break;
	case SONPROC:
		dprintf("[SONPROC] ");
		break;
	case SXBRK:
		dprintf("[SXBRK] ");
		break;
	}
#endif
}


ppflag(p)
struct proc *p;
{
#if 0
	if (p->p_flag & SSYS)
		printf("SSYS ");
	if (p->p_flag & STRC)
		printf("STRC ");
	if (p->p_flag & SNWAKE)
		printf("SNWAKE ");
	if (p->p_flag & SLOAD)
		printf("SLOAD ");
	if (p->p_flag & SLOCK)
		printf("SLOCK ");
	if (p->p_flag & SPOLL)
		printf("SPOLL ");
	if (p->p_flag & SPRSTOP)
		printf("SPRSTOP ");
	if (p->p_flag & SPROCTR)
		printf("SPROCTR ");
	if (p->p_flag & SPROCIO)
		printf("SPROCIO ");
	if (p->p_flag & SPROPEN)
		printf("SPROPEN ");
	if (p->p_flag & SULOAD)
		printf("SULOAD ");
	if (p->p_flag & SRUNLCL)
		printf("SRUNLCL ");
	if (p->p_flag & SNOSTOP)
		printf("SNOSTOP ");
	if (p->p_flag & SPTRX)
		printf("SPTRX ");
	if (p->p_flag & SASLEEP)
		printf("SASLEEP ");
	if (p->p_flag & SUWANT)
		printf("SUWANT ");
#endif
}



dppflag(p)
struct proc *p;
{
#if 0
	if (p->p_flag & SSYS)
		dprintf("SSYS ");
	if (p->p_flag & STRC)
		dprintf("STRC ");
	if (p->p_flag & SNWAKE)
		dprintf("SNWAKE ");
	if (p->p_flag & SLOAD)
		dprintf("SLOAD ");
	if (p->p_flag & SLOCK)
		dprintf("SLOCK ");
	if (p->p_flag & SPOLL)
		dprintf("SPOLL ");
	if (p->p_flag & SPRSTOP)
		dprintf("SPRSTOP ");
	if (p->p_flag & SPROCTR)
		dprintf("SPROCTR ");
	if (p->p_flag & SPROCIO)
		dprintf("SPROCIO ");
	if (p->p_flag & SPROPEN)
		dprintf("SPROPEN ");
	if (p->p_flag & SULOAD)
		dprintf("SULOAD ");
	if (p->p_flag & SRUNLCL)
		dprintf("SRUNLCL ");
	if (p->p_flag & SNOSTOP)
		dprintf("SNOSTOP ");
	if (p->p_flag & SPTRX)
		dprintf("SPTRX ");
	if (p->p_flag & SASLEEP)
		dprintf("SASLEEP ");
	if (p->p_flag & SUWANT)
		dprintf("SUWANT ");
#endif
}


/*	Print the plocal structure for a given cpu.  The default is the
 *	current cpu.
 */
plocal()
{
}


/*	Print a text description of an inode to the console.	
 */

pufs_inode(ip)
{
}


/*	Print a text description of a page_t structure to the console.	
 */

ppage(p)
{
#if 0
	char flags;
	flags = p->p_flg.pp_flag & 0xff;

	printf("p_hashnext %x  p_hashprev %x p_vnode %x p_offset %x\n" ,
	p->p_hashnext, p->p_hashprev, p->p_vnode, p->p_offset);
	printf("pp_nio %x  pp_keepcnt %x p_flags %x \n", p->p_flg.page_bits.pp_nio,
	p->p_flg.page_bits.pp_keepcnt, flags);
	printf("Flags: ");
	if (flags & PP_WANT) printf("PP_WANT ");
	if (flags & PP_FREE) printf("PP_FREE ");
	if (flags & PP_INTRANS) printf("PP_INTRANS ");
	if (flags & PP_GONE) printf("PP_GONE ");
	if (flags & PP_MOD) printf("PP_MOD ");
	if (flags & PP_REF) printf("PP_REF ");
	if (flags & PP_PAGEIN) printf("PP_PAGEIN ");
	if (flags & PP_AGE) printf("PP_AGE ");
	printf("\n");
	printf("p_next %x  p_prev %x p_vpnext %x p_vpprev %x\n" ,
	p->p_next, p->p_prev, p->p_vpnext, p->p_vpprev);
	printf("p_spinlock %x  p_cowcnt %x p_lckcnt %x p_swapfree %x\n" ,
	p->p_spinlock, p->p_cowcnt, p->p_lckcnt, p->p_swapfree);
	printf("p_dblist[0] %x  p_dblist[1] %x p_dblist[2] %x p_dblist[3] %x\n" ,
	p->p_dblist[0], p->p_dblist[1], p->p_dblist[2], p->p_dblist[3]);
#endif
}

/*	Print a text description of a tty structure to the console.	
 */

ptty(t)
{
}

/*	Print a text description of a clist structure to the console.	
 */

pclist(p)
{
}


/*	Print the characters in a cblock structure to the console.	
 */

pcblock(p)
{
}


/*	Print the semaphore structure to the console.	
 */

psemaphore(p)
{
}


int	current_mark;

/*	Place a blank mark and a label in the trace buffer.  This is used
 *	to mark a place in the trace buffer.
 */
markbuf()
{
}


/*	Return a pointer to a character string containing the error name
 */

char *
enamestr( errno )
{
	return( &enames[errno][0]);
}

/*	Return the address that the caller was called from.  This can be used
 *	in debug printfs to find out who called a routine that has a problem
 *	without entering the debugger and doing a full backtrace.
 *	spntadr() can be used to print the symbolic string for the address.
 *	e.g.
 *	dprintf("Called from %x %s\n", called_from(), spntadr(called_from()));
*/
called_from()
{
	unsigned int *frameptr;

	frameptr = (unsigned int *)get_fp(); 	/* current frame pointer */
	return ((int)frameptr[1]);
}

/*	Return the address of the caller of the caller.
 */
called_from2()
{
	unsigned int *frameptr;

	frameptr = (unsigned int *)get_fp(); 	/* current frame pointer */
	frameptr = ((unsigned int *)frameptr[0]);
	return ((int)frameptr[1]);
}

/*	Return the address of the caller of the caller of the caller. 
 */
called_from3()
{
	unsigned int *frameptr;

	frameptr = (unsigned int *)get_fp(); 	/* current frame pointer */
	frameptr = ((unsigned int *)frameptr[0]);
	frameptr = ((unsigned int *)frameptr[0]);
	return ((int)frameptr[1]);
}

void
killall(sig)
int sig;
{
#if 0
	struct proc *p;

	if (sig < 1 || sig >= NSIG)
		sig = SIGKILL;
	for (p = proc; p < (struct proc *) v.ve_proc; ++p) {
		if ((p->p_flag & SSYS) || (p->p_ppid == 0))
			continue;
		psignal(p, sig);
	}
#endif
}

