
#include "debugger.h"


int	dbdebugflag = 0;
int	ipl;

static 	int 	dbsave[32];

extern 	char		mneu[];

char trap0_msg[] = "Divide by zero\n";
char trap1_msg[] = "Debug execption\n";
char trap2_msg[] = "NMI trap\n";
char trap3_msg[] = "Breakpoint trap\n";
char trap4_msg[] = "Overflow trap\n";
char trap5_msg[] = "Bounds check trap\n";
char trap6_msg[] = "Invalid Opcode\n";
char trap7_msg[] = "Coprocessor not available\n";
char trap8_msg[] = "Double fault\n";
char trap9_msg[] = "Coprocessor sgement overrun\n";
char trap10_msg[] = "Invalid TSS\n";
char trap11_msg[] = "Segment not present\n";
char trap12_msg[] = "Stack exception\n";
char trap13_msg[] = "General protection exception\n";
char trap14_msg[] = "Page fault\n";

char *trap_msg[] =  {
	  trap0_msg,  trap1_msg,  trap2_msg,    trap3_msg,  trap4_msg,
  	  trap5_msg,  trap6_msg,  trap7_msg,    trap8_msg,  trap9_msg,
  	  trap10_msg, trap11_msg, trap12_msg,   trap13_msg, trap14_msg };

debugger(r0ptr, why)
    	int 	*r0ptr;
    	int 	why;
{
	int	prt_where;
	int	i;
	
    	if (dbflags & DB_ACTIVE) {
		printf( "Restarting debugger\n" );
		longjmp(dbsave);
    	} 
    	if ((dbflags & DB_ENABLE) == 0) {
		dbflags |= DB_ENABLE;		/* CTRL-B enabled */
		expr_init();
	}
	
	((flags_t *)&r0ptr[EFL])->fl_tf = 0; /* turn off trace */

    	dbr0ptr = r0ptr;
    	dbwhy = why;
	ifptout();
	if (brptout() == 0)
		goto doret;
    	dbflags &= ~DB_CTRLB;
	if (dbflags & DB_INSTEP)
		goto doret;

	dbflags |= DB_ACTIVE;

	if (dbdebugflag)
		btrace(_rdebp(), 0);
	
    	if (setjmp(dbsave) == 0) {
		dbspl = saveflg();
		asm("cli");
		if (dbspl & 0x200)
			ipl = 8;
		else
			ipl = 0;
		drcmd(why);
	}

    	dbinterp();
	restflg(dbspl);

	dbflags &= ~(DB_ACTIVE|DB_CTRLB);

doret:
	brptin();
	ifptin();
}

dbstepping(r0ptr)
{
	int	debugstatus =  _dr6();

	_wdr6(0);
	/* Now evaluate how we got here */
	if (debugstatus & (DR_TRAP0|DR_TRAP1|DR_TRAP2|DR_TRAP3)) {
		if (ifbrpt(debugstatus, r0ptr) == 0 &&
		    (debugstatus & DR_SINGLESTEP) == 0)	
			return(1);
		debugger(r0ptr, 1);
		return(1);
	}
	/* We may land here if 'sdb/dbx' single step the lcall inst */
	if ((debugstatus & DR_SINGLESTEP) && 
	    dbstepflg == 0 && (dbflags & DB_INSTEP) == 0)
		return(0);
	debugger(r0ptr, 1);
	return(1);
}

kdblongjmp(r0ptr)
	int	*r0ptr;
{
	if (dbflags & DB_ACTIVE) { 
		printf("\nKDB> Error: %s", trap_msg[r0ptr[TRAPNO]]);
		printf("KDB> %%CR2: 0x%x %%EIP: 0x%x\n", _cr2(), r0ptr[EIP]);
		dbdebugflag && btrace(r0ptr[EBP], 0);
		longjmp(dbsave, 1);
	}
}

