	.set	NBPW, 4		/ no of bytes in a word.

	.set    CR0_ET, 0x10            / extension type (1->387,0->???)
	.set    CR0_TS, 0x08            / task switched
	.set    CR0_EM, 0x04            / use math emulation
	.set    CR0_MP, 0x02            / math coprocessor present
	.set    CR0_PE, 0x01            / protection enable

	.text

	.align	4
	.globl	scanbit
	.globl	ffs0
scanbit:
ffs0:
	movl	4(%esp), %edx		/ mask
	bsfl	%edx, %eax
	ret

	.globl	dbint3
	.align	4
dbint3:
	int	$3
	ret

	.globl	_cr0
_cr0:
	movl	%cr0, %eax
	ret

	.globl	sgdt
sgdt:
	movl	4(%esp), %eax
	sgdt	(%eax)
	ret

	.globl	_cr2
_cr2:
	movl	%cr2, %eax
	ret

	.globl	_cr3
_cr3:
	movl	%cr3, %eax
	ret

	.globl	_wcr0
_wcr0:
	movl	4(%esp), %eax
	movl	%eax, %cr0
	ret

	.globl	_rdebp
_rdebp:
	movl	%ebp, %eax
	ret

	.globl	_rdcs
_rdcs:
	xorl	%eax, %eax
	movw	%cs, %ax
	ret

	.globl  _rdgs
_rdgs:
	xorl	%eax, %eax
	movw    %gs, %ax
	ret

	.globl  _rdfs
_rdfs:
	xorl	%eax, %eax
	movw    %fs, %ax
	ret

	.globl  _rdes
_rdes:
	xorl	%eax, %eax
	movw    %es, %ax
	ret

	.globl  _wrgs
_wrgs:
	movl    4(%esp), %eax
	movw    %ax, %gs
	ret

	.globl  _wrfs
_wrfs:
	movl    4(%esp), %eax
	movw    %ax, %fs
	ret

	.globl  _wres
_wres:
	movl    4(%esp), %eax
	movw    %ax, %es
	ret

	.align	4
	.globl	get_tr
get_tr:
	xorl	%eax, %eax
	str	%ax
	ret

/       load task register
	.globl  loadtr
	.align	4
loadtr:
	movw	4(%esp), %ax
	ltr	%ax
	ret


/	return the current frame pointer

	.align	4
	.globl  get_fp
get_fp:
	movl    %ebp, %eax
	ret

	.globl	saveflg
saveflg:
	pushf
	popl	%eax
	ret

	.set	FLAGS, 8

	.globl	restflg
restflg:
	pushl	%ebp
	movl	%esp, %ebp
	movl	FLAGS(%ebp), %eax
	pushl	%eax
	popf
	popl	%ebp
	ret

	.globl	_dr0
_dr0:
	movl	%dr0, %eax
	ret

	.globl	_dr1
_dr1:
	movl	%dr1, %eax
	ret

	.globl	_dr2
_dr2:
	movl	%dr2, %eax
	ret

	.globl	_dr3
_dr3:
	movl	%dr3, %eax
	ret

	.globl	_dr6
_dr6:
	movl	%dr6, %eax
	ret

	.globl	_dr7
_dr7:
	movl	%dr7, %eax
	ret

	.globl	_wdr0
_wdr0:
	movl	4(%esp), %eax
	movl	%eax, %dr0
	ret

	.globl	_wdr1
_wdr1:
	movl	4(%esp), %eax
	movl	%eax, %dr1
	ret

	.globl	_wdr2
_wdr2:
	movl	4(%esp), %eax
	movl	%eax, %dr2
	ret

	.globl	_wdr3
_wdr3:
	movl	4(%esp), %eax
	movl	%eax, %dr3
	ret
	
	.globl	_wdr6
_wdr6:
	movl	4(%esp), %eax
	movl	%eax, %dr6
	ret
	
	.globl	_wdr7
_wdr7:
	movl	4(%esp), %eax
	movl	%eax, %dr7
	ret

	.set	IOPORT, 4
	.set	VAL, 8

	.globl	_outl
	.align	4
_outl:	
	movw	IOPORT(%esp), %dx
	movl	VAL(%esp), %eax
	outl	(%dx)
	ret

	.globl	_outw
	.align	4
_outw:	
	movw	IOPORT(%esp), %dx
	movw	VAL(%esp), %ax
	outw	(%dx)
	ret

	.globl	_outb
	.align	4
_outb:	
	movw	IOPORT(%esp), %dx
	movb	VAL(%esp), %al
	outb	(%dx)
	ret

	.globl	_inl
	.align	4
_inl:	
	movw	IOPORT(%esp), %dx
	inl	(%dx)
	ret

	.globl	_inw
	.align	4
_inw:	
	subl    %eax, %eax
	movw	IOPORT(%esp), %dx
	inw	(%dx)
	ret

	.globl	_inb
	.align	4
_inb:	
	subl    %eax, %eax
	movw	IOPORT(%esp), %dx
	inb	(%dx)
	ret

