
/*
 * dbcon.c
 *	kernel debugger basic I/O routines
 *
 */


#include "debugger.h"

/*
 * This will capture a line of text typed on the console up
 * to a newline.  This echos and will handle erase and kill for line editing.
 */

dbgetc()
{
	int	c;

	while ((c = getchar()) < 0);
	return(c & 0x7f);
}

dbgets(p, n)
{
	gets(p, n);
}

static	char	moremsg[] = "--MORE-- <y/n>? ";

nomore()
{
	int	i;
	char	c;

	printf(moremsg); 
	c = dbgetc();
	if (c == 'n' || c == 'N') {
		printf("%c\n", c);
		return(1);
	}
	for(i = sizeof(moremsg) - 1; i > 0; --i)
		putchar(0x08);
	for(i = sizeof(moremsg) + 1; i > 0; --i)
		putchar(0x20);
	for(i = sizeof(moremsg) + 1; i > 0; --i)
		putchar(0x08);
	return(0);
}
