#include "debugger.h"

long	ktrace;
long	ktraceb;
long	ktracec;

extern 	int	cmderr();

extern	int	bkcmd();
extern	int	ckcmd();

extern	int	alcmd();
extern	int	ifcmd();
extern	int	iccmd();
extern	int	brcmd();
extern	int	rbcmd();
extern	int	bccmd();
extern	int	cacmd();
extern  int     dgcmd();
extern	int	btcmd();
extern	int	cdcmd();
extern	int	dmcmd();
extern	int	dicmd();
extern	int	di16cmd();
extern	int	sicmd();
extern	int	Smcmd();
extern  int     dpcmd();
extern	int	drcmd();
extern  int     dtcmd();
extern	int	evcmd();
extern	int	fwcmd();
extern	int	gocmd();
extern	int	hecmd();
extern	int	mrcmd();
extern	int	mlcmd();
extern	int	mscmd();
extern	int	mbcmd();
extern	int	ofcmd();
extern	int	pfcmd();
extern	int	prcmd();
extern	int	secmd();
extern	int	tocmd();
extern	int	trcmd();
extern	int	vscmd();
#ifdef at386
extern	int	picmd();
#endif
#ifdef TCP
extern	int prifnet();
extern	int prinpcb();
extern	int prmbuf();
extern	int prso();
extern	int prunpcb();
extern	int ptcmd();
#endif
extern	int uacmd();
extern	int hicmd();


nocmd()
{
	printf("Command not yet implemented\n");
	return(0);
}

struct	cmdtable {
	char	c1;
	char	c2;
	int	(*func)();
	char	*c_help1;
	char	*c_help2;
} cmdtable[] = {
	{ 'a', 'l', alcmd, "[name text]","(alias name to text)" },
	{ 'b', 'r', brcmd, "[addr]","(set/display bkpts)" },
	{ 'b', 'c', bccmd, "[addr]","(clear [all] bkpts)" },
	{ 'b', 't', btcmd, "[addr]","(stack backtrace)" },
	{ 'd', 'g', dgcmd, "addr","(display descriptor table)" },
	{ 'd', 'l', dmcmd, "addr[,count]","(display long)" },
	{ 'd', 's', dmcmd, "addr[,count]","(display shorts)" },
	{ 'd', 'w', dmcmd, 0, 0 },
	{ 'd', 'b', dmcmd, "addr[,count]","(display bytes)" },
	{ 'd', 'i', dicmd, "addr[,count]","(display inst)" },
	{ 'd', '6', di16cmd, "addr[,count]","(display inst 16-bit mode)" },
	{ 's', 'i', sicmd, "string addr[,count]","(search inst)" },
	{ 's', 'l', Smcmd, "value addr[,count]","(search long)" },
	{ 's', 's', Smcmd, "value addr[,count]","(search short)" },
	{ 's', 'w', Smcmd, 0, 0 },
	{ 's', 'b', Smcmd, "value addr[,count]","(search byte)" },
	{ 'd', 'p', dpcmd, "addr","(display page table)" },
	{ 'd', 'r', drcmd, "","(display all regs)" },
	{ 'd', 't', dtcmd, "addr","(display tss)" },
	{ 'e', 'v', evcmd, "expr","(evaluate expression)" },
	{ 'f', 'w', fwcmd, 0, 0 },
	{ 'g', 'o', gocmd, "[addr]","(start execution)" },
	{ 'h', 'e', hecmd, 0, 0 },
	{ 'h', 'i', hicmd, "","(history)" },
	{ 'i', 'f', ifcmd, "[addr REL expr]","('if ?' for more info)" },
	{ 'i', 'c', iccmd, "[addr]","(clear [all] data bkpts)" },
#ifdef TCP
	{ 'n', 'f', prifnet, "[addr|interface]","(display interface structure)" },
	{ 'n', 'i', prinpcb, "addr","(display inet protocol control block)" },
	{ 'n', 'm', prmbuf, "addr","(display mbuf)" },
	{ 'n', 's', prso,  "addr","(display socket structure)" },
	{ 'n', 'u', prunpcb, "addr","(display unix protocol control block)" },
#endif
	{ 'k', '?', nocmd, "","(toggle k?printf)" },
	{ 'b', 'k', bkcmd, "","(toggle k?printf [buffer only])" },
	{ 'c', 'k', ckcmd, "","(toggle k?printf [console only])" },
	{ 'm', 'r', mrcmd, "","(modify register)" },
	{ 'm', 'l', mlcmd, "addr","(modify long)" },
	{ 'm', 's', mscmd, "addr","(modify short)" },
	{ 'm', 'w', mscmd, 0, 0 },
	{ 'm', 'b', mbcmd, "addr","(modify byte)" },
	{ 'o', 'f', ofcmd, "[proc_addr]","(dump per user ofile)" },
	{ 'p', 'f', pfcmd, "","(show printf buffer)" },
#ifdef at386
	{ 'p', 'i', picmd, "","(show pic state)" },
#endif
	{ 'p', 'r', prcmd, "[addr]","(dump proc table)" },
	{ 'r', 'b', rbcmd, "", "(set break on return)" },
	{ 's', 'e', secmd, "var=expr","(assign value to variable)" },
	{ 't', 'o', tocmd, "[expr]","(trace, no display)" },
	{ 't', 'r', trcmd, "[expr]","(trace 'expr' insts)" },
#ifdef TCP
	{ 'p', 't', ptcmd, "addr|unit","(display ptty structure)" },
#endif
	{ 'u', 'a', uacmd, "[name","(unalias name)" },
	{ 'v', 's', vscmd, "","(show kernel version)" },
	{ '\0', '\0', cmderr }
};


char save_cmd[MAXLINE];

dbinterp()
{
	register char	c1, c2;
	register struct	cmdtable	*cmdtabptr;
	int aliascnt, fval, entcmd;
	char *multi, *find_semi();
	extern char *bp_has_cmd;

	for(;;) {	
		aliascnt = 0;
		entcmd = 0;
		if (bp_has_cmd) {
			strcpy(cmdline,bp_has_cmd);
			bp_has_cmd = NULL;
			goto parsecmdline;
		}
		if (dbcmd)
			goto parsecmdline;
		if (dbstepflg)
			printf("<%s> ",lastcmdline);
		else
			printf("KDB> ");
		if((entcmd = dbgets(cmdline, sizeof(cmdline))) == 0) {
			if (dbstepflg==0) 
				continue;
			strcpy(cmdline, lastcmdline);
		}
		dbstepflg = 0;
		if (expand_history(cmdline) == -1)
			continue;
		add_history(cmdline);
parsecmdline:
		dbcmd = 0;
		cmdptr = cmdline;
		skipsp();
		/*
		** trim off all leading ';'
		*/
		while (*cmdptr == ';') {
			*cmdptr++ = ' ';
			skipsp();
		}
		if (multi = find_semi(cmdptr)) {
			strcpy(save_cmd,multi);
			*multi = '\0';
		}
		if (*cmdptr == '\0') {
			fval = 0;
			goto skipcmd;
		}
		c1 = dbtolower(*cmdptr++);
		c2 = dbtolower(*cmdptr++);
		for(cmdtabptr=cmdtable; cmdtabptr->c1; cmdtabptr++) {
			if((c1 == cmdtabptr->c1) && (c2 == cmdtabptr->c2))
				break;
		}
		if (cmdtabptr->c1 && entcmd) {
			strcpy(lastcmdline, cmdline);
			entcmd = 0;
		} else if (c1 == (char)'\'' && c2 == (char)'\0') {
			strcpy(cmdline,lastcmdline);
			if (multi)
				strcat(cmdline,save_cmd);
			goto parsecmdline;
		}
		dbexitflg = 0;
		if (c1 == 'k')
			fval = kpcmd(c2);
		else {
			if (doalias()) {
				if (++aliascnt > 20) {
					printf("alias loop\n");
					continue;
				}
				if (multi)
					strcat(cmdline,save_cmd);
				goto parsecmdline;
			}
			skipnsp();
			skipsp();
			fval = (*cmdtabptr->func)(c2);
		}
		if (dbexitflg)
			break;
skipcmd:
		/*
		** if function call failed then stop
		** executing commands
		*/
		if (multi && fval == 0) {
			/*
			** skip leading ';'
			*/
			strcpy(cmdline,save_cmd+1);
			dbcmd = 1;
		}
	}
}

static char *
find_semi(s)
	register char *s;
{
	int brackcnt = 0;

	while (*s) {
		if (*s == '[')
			brackcnt++;
		else if (*s == ']')
			brackcnt--;
		else if (*s == '\\') {
			*s++ = ' ';	/* eliminate '\' */
			if (*s == '\0')
				break;
		} else if (*s == ';' && brackcnt <= 0)
			return(s);
		s++;
	}
	return(NULL);
}

bkcmd()
{
	char c;

	ktrace &= ~ktraceb;		/* turn off all current bk's */

	c = *cmdptr++;
	kcmd(c, &ktraceb);

	ktrace |= ktraceb;		/* turn on now current bk's */
}

ckcmd()
{
	char c;

	ktrace &= ~ktracec;		/* turn off all current ck's */

	c = *cmdptr++;
	kcmd(c, &ktracec);

	ktrace |= ktracec;		/* turn on now current ck's */
}

kpcmd(c)
{
	kcmd(c, &ktrace);
	ktraceb &= ~ktrace;		/* turn off bk flags */
	ktracec &= ~ktrace;		/* turn off ck flags */
}

kcmd(c, ktracep)
	char	c;
	long	*ktracep;
{
	int	i, j;
	int	onoff, val;
	long	ktrace;

	ktrace = *ktracep;

	if (c == '?' || c == 0) {
		if (ktrace == 0)
			printf("-NONE-\n");
		else {
			for(j=1, i=0; i<=25; ++i) {
				if (ktrace & j) 
					printf("%c ", i+'a');
				j <<= 1;
			}
			printf("\n");
		}
		return;
	}

	onoff = 0;

	do {
		if (c == '0') {
			onoff = 1;
			val = 0;
			continue;
		} else if (c == '1') {
			onoff = 1;
			val = 1;
			continue;
		} else if (c == ' ') {
			continue;
		}
		if (c < 'a' && c > 'z') {
			cmderr();
			return;
		}

		i = 1 << (c - 'a');
		if (onoff) {
			if (val) {
				printf("k%cprintf ON\n", c);
				ktrace |= i;
			} else {
				printf("k%cprintf OFF\n", c);
				ktrace &= ~i;
			}
		} else if (ktrace & i) {
			printf("k%cprintf OFF\n", c);
			ktrace &= ~i;
		} else {
			printf("k%cprintf ON\n", c);
			ktrace |= i;
		}
	} while(c = *cmdptr++);
	*ktracep = ktrace;
}

fwcmd()
{
}

cmderr()
{
	printf("Command error\n");
}


evcmd()
{
	int	num;

	num = evalexp(-1);
	if (experr)
		return(-1);
	printf("    %x (", num );
	pntadr( num );
	printf(") %d.\n", num);
	dot = (char *)num;
	return(0);
}

hecmd()
{
	struct cmdtable *cmdtabptr;
	int i;

	i = 1;
	for(cmdtabptr=cmdtable; cmdtabptr->c1; cmdtabptr++) {
		if (cmdtabptr->c_help1 == NULL)
			continue;
		if ((i % 20) == 0 && nomore())
			break;
		printf("%c%c %-20s %s\n",cmdtabptr->c1,cmdtabptr->c2,
				cmdtabptr->c_help1,cmdtabptr->c_help2);
		i++;
	}
	return(0);
}

pfcmd()
{
}

dbprompt()
{
	dbcmd = 0;
	if(dbgets(cmdline, sizeof(cmdline)) != 0) {
		cmdptr = cmdline;
		skipsp();
		if (*cmdptr != '.' && *cmdptr != '-')
			dbcmd = 1;
		return(1);
	}
	return(0);
}

