
#include "debugger.h"

extern	char	mneu[];
extern	int	ipl;

static
getspl()
{
	return(ipl);
}

display_flags(flags)
	register int 	flags;
{
  	printf("\nSPL: 0x%02x Flags: %06x ", dbspl, flags);
   	(flags & PS_VM) && printf("Vm86 ");
   	(flags & PS_RF) && printf("R ");
   	(flags & PS_NT) && printf("Nt ");
   	(flags & PS_IOPL) && printf("IOPL=%d ", (flags&PS_IOPL) >> 12);
   	(flags & PS_V) && printf("Ovf ");
   	(flags & PS_D) && printf("Dir ");
   	(flags & PS_IE) && printf("IE ");
   	(flags & PS_T) && printf("Trap ");
   	(flags & PS_N) && printf("S ");
   	(flags & PS_Z) && printf("Z ");
   	(flags & PS_AC) && printf("Ac ");
   	(flags & PS_P) && printf("P ");
   	(flags & PS_C) && printf("C ");
 }

drcmd(trapno)
{
	register int	*r0ptr;
	int		adr;
	int 		cr0 = _cr0();
	int 		cr2 = _cr2();
	int 		cr3 = _cr3();
	int		ss, esp;

	r0ptr = dbr0ptr;
	esp = (int) &r0ptr[UESP];
	ss = 0x18;
	if (r0ptr[CS] & 3) {
		esp = r0ptr[UESP];
		ss = r0ptr[SS] & 0xffff;
	}
	if (trapno != 1) {
		display_flags(r0ptr[EFL]);
		printf("    CS: %04x  SS: %04x\n", r0ptr[CS]&0xffff, ss);
	}
	printf("EAX: %08x  EBX: %08x  ECX: %08x  EDX: %08x  CR2: %08x\n",
	       r0ptr[EAX], r0ptr[EBX], r0ptr[ECX], r0ptr[EDX], cr2);
	printf("ESI: %08x  EDI: %08x  EBP: %08x  ESP: %08x  CR3: %08x\n",
		r0ptr[ESI], r0ptr[EDI], r0ptr[EBP], esp, cr3);
	
	dot = (char *)r0ptr[EIP];
	if (r0ptr[EFL] & PS_VM)			/* CS:IP is real mode addr */
		dbflags |= DB_REALMODE;
	if (trapno == -1)
		printf("Kernel trap(%d) at ", r0ptr[TRAPNO]);
	else
	if (trapno == 1)
		printf("Stopped at ");
	else
	if (trapno == 3)
		printf("BreakPoint at ");
	pntadr(dot);
	printf(": \t");
	/*
	** translate logical address to linear
	** address if in user address space
	*/
	adr = logtolin(dot,r0ptr[CS]);
	dis_dot(adr); 
	printf("%s\n", mneu); 
	return(0);
}

dmcmd(type)
	char	type;
{
	int	i;
	uchar	*p;
	char	c;

	if (getaddr(1)) {
		if (experr)
			return(-1);
	} else {
		addr.a_char = dot;
		remref = lremref;
	}
	if (remref < 0)
		remref = 1;
	else if (remref > 20)
		remref = 20;
	for(;;) {
		disp_mem(dot = addr.a_char, type, 0);
		if (remref) {
			printf("\n");
			addr.a_char += 16;
			dot += 16;
			remref--;
			if (remref == 0)
				break;
			continue;
		}
		if(dbprompt()) {
			if (*cmdptr != '-')
				return(0);
			addr.a_char -= 16;
		} else
			addr.a_char += 16;
	}
	return(0);
}


/*
 * Display page table entry
 */

dpcmd()
{
#if 0
  	pde_t *pt;
	dbd_t *dbd;

	if(getwaddr() == 0 || experr) return(-1);
	for(;;) {
		dot = addr.a_char;
		pt = (pde_t *)addr.a_int;
		dbd = (dbd_t *)addr.a_int;
		printf("%s:\t", spntadr(pt));
		if (pt->pgm.pg_pres) {
		  	printf("PT:  %08x ",pt->pgm.pg_pfn);
			if (pt->pgm.pg_rw)
				printf("RW ");
			else
				printf("RO ");
			dps(pt->pgm.pg_us,"User ");
			dps(pt->pgm.pg_cw,"Cw ");
			dps(pt->pgm.pg_ref,"Ref ");
			dps(pt->pgm.pg_mod,"Mod ");
			dps(pt->pgm.pg_ndref,"Ndref ");
			dps(pt->pgm.pg_lock,"Lk ");
		} else {
			printf("DBD: ");
			if (dbd->dbd_type < DBD_SWAP)
				printf("         ");
			else
				printf("%08x ",dbd->dbd_blkno);
			if (dbd->dbd_prot & PG_RW)
				printf("RW ");
			else
				printf("RO ");
			dps(dbd->dbd_prot & PG_US,"User ");
			dps(dbd->dbd_cw,"Cw ");
			switch (dbd->dbd_type) {
			case DBD_NONE:
				printf("None ");
				break;
			case DBD_DZERO:
				printf("Zero ");
				break;
			case DBD_DFILL:
				printf("Fill ");
				break;
			case DBD_SWAP:
				printf("Swap(%d) ",dbd->dbd_swpi);
				break;
			case DBD_FILE:
				printf("File ");
				break;
			case DBD_LSTFILE:
				printf("Last ");
				break;
			}
		}
		if(dbprompt()) {
			if (*cmdptr != '-')
				return(0);
                	addr.a_int--;
		} else
                	addr.a_int++;
	}
#endif
}


dps(expr,s)
int expr;
char *s;
{
	int len;

	if (expr)
		printf("%s", s);
	else {
		len = strlen(s);
		while (len-- > 0)
			printf(" ");
	}
}


/*
 * Display descriptor
 */

dgcmd()
{
#if 0
  	struct gate *cg;
  	struct segdesc *cs;
  	unsigned base, limit;
  	int gate_type;

	if(getwaddr() == 0 || experr) return(-1);
	for(;;) {
		dot = addr.a_char;
		cg = (struct gate *)addr.a_int;
		cs = (struct segdesc *)addr.a_int;
		printf("%s: \t", spntadr(addr.a_int));
		if (cs->s1.system_seg) {
		    	if (cs->s1.executable) {
		      		printf("Exec ");
				if (cs->s1.e_or_c)
					printf("Cform ");
				if (cs->s1.w_or_r)
					printf("R ");
				if (cs->s1.b_or_d)
					printf("Default ");
		    	} else {
		      		printf("Data ");
				if (cs->s1.e_or_c)
					printf("Xpdn ");
				if (cs->s1.w_or_r)
					printf("RW ");
				else
					printf("R ");
				if (cs->s1.b_or_d)
					printf("Big ");
			}
			if (cs->s1.g)
				printf("Gran ");
		    	printf("Seg ");
		    	if (cs->s1.a)
		      		printf("Accessed ");
			else
			if (cs->s1.p)
				printf("Present ");

			base = (cs->s1.base3124 << 24) |
			       (cs->s1.base2316 << 16) | cs->base_low;
			limit = (cs->s1.limit1916 << 16) | cs->limit_low;
			
			printf(" Base: %x (%x) Dpl: %d", base, limit, cs->s1.dpl);
		} else {
                	gate_type = cg->g_type & 0xf;
                	if (gate_type == GATE_386INT)
                   		printf("386 Interrupt gate");
                	else if (gate_type == GATE_286INT)
                   		printf("286 Interrupt gate");
                	else if (gate_type == GATE_386TRP)
                   		printf("386 Trap gate");
                	else if (gate_type == GATE_286TRP)
                   		printf("386 Trap gate");
                	else if (gate_type == GATE_LDT)
                   		printf("LDT");
                	else if (gate_type == GATE_386CALL)
                   		printf("386 Call gate");
                	else if (gate_type == GATE_286CALL)
                   		printf("286 Call gate");
                	else if (gate_type == GATE_TSS)
                   		printf("Task gate");
                	else if (gate_type == GATE_386_AVAIL_TSS)
                   		printf("386 Available TSS gate");
                	else if (gate_type == GATE_386_BUSY_TSS)
                   		printf("386 Busy TSS gate");
                	else
                   		printf("Unknown gate type: %d", gate_type);

			base = cg->g_sel;
			printf(" Selector: %04x ", base);
			if (gate_type != GATE_TSS) {
				limit = (cg->g_hioff << 16) | cg->g_looff;
				printf("Offset: %s",spntadr(limit));
			}
	      	}
		if(dbprompt()) {
			if (*cmdptr != '-')
				return(0);
                   	addr.a_int -= 2;
                } else
		  	addr.a_int += 2;     
	}
#endif
}

/*
 * Display TSS
 */

dtcmd()
{
  	struct tss386 *ts;

	if(getwaddr() == 0 || experr) return(-1);
	dot = addr.a_char;
	ts = (struct tss386 *)addr.a_int;
  
        printf("SP0: %x:%x, SP1: %x:%x, SP2: %x:%x\n",
                ts->t_ss0, ts->t_esp0, ts->t_ss1, ts->t_esp1,
                ts->t_ss2, ts->t_esp2);
        printf("CR3: %x, IP: %x BackLink: %x BitMap: %x\n", 
		ts->t_cr3, ts->t_eip, ts->t_link, ts->t_bitmapbase);
	display_flags(ts->t_eflags);
	printf("\n");
        printf("EAX: %08x, ECX: %08x, EDX: %08x, EBX: %08x\n",
		ts->t_eax, ts->t_ecx, ts->t_edx, ts->t_ebx);
        printf("ESP: %08x, EBP: %08x, ESI: %08x, EDI: %08x\n",
		ts->t_esp, ts->t_ebp, ts->t_esi, ts->t_edi);
        printf("ES: %x, CS: %x, SS: %x, DS: %x, FS: %x, GS: %x, LDT: %x\n",
		ts->t_es, ts->t_cs, ts->t_ss, ts->t_ds,
		ts->t_fs, ts->t_gs, ts->t_ldt);
	return(0);
}

#ifdef at386
/*
** Display state of pics (master and slave)
*/

#define	MAX_PIC	2

picmd()
{
}
#endif


#ifdef TCP
ptcmd()
{
}
#endif	TCP

vscmd()
{
	return(0);
}

ofcmd()
{
	return(0);
}

prcmd()
{
	return(0);
}

struct	dr_regs	{
	char	*name;
	short	index;
} dr_regs[] = {
	{ "EAX", EAX }, { "EBX", EBX }, { "ECX", ECX }, { "EDX", EDX }, 
	{ "ESI", ESI }, { "EDI", EDI }, { "EIP", EIP }, { "", 0 }, 
};

mrcmd()
{
	register struct	dr_regs	*pt;

	for(pt=dr_regs; *(pt->name) != '\0'; ) {
		printf(pt->name);
		printf("=%X ", dbr0ptr[pt->index]);
		dot = (char *)dbr0ptr[pt->index];
		if(dbprompt()) {
			if (*cmdptr == '-') {
				if (pt > dr_regs)
					pt--;
			} else {
				if(getvalue() == 0) return(0);
				dbr0ptr[pt->index] = value;
				pt++;
			}
		} else
			pt++;
	}
	dbcmd = 0;
	return(0);
}

	
extern	int dis_16_bits;
di16cmd()
{
	dis_16_bits = !dis_16_bits;
	dicmd();
	dis_16_bits = !dis_16_bits;
}

dicmd()
{
	int	d16, count;
	char	*ip;
	extern	int  _stext();

	if (getaddr(1)) {
		if (experr)
			return(-1);
	} else
		addr.a_char = dot;
	ip = addr.a_char;
	if (remref < 1)
		remref = 1;
	else if (remref > 20)
		remref = 20;
	for ( ;; ) {
		dot = ip;
		d16 = dis_16_bits;
		if ((unsigned long)ip >= (unsigned long) _stext)
			dis_16_bits = 0;
		for (count = remref; count--; ) {
			pntadr(ip);
			printf(": \t" );
			ip = (char *) dis_dot(ip);
			printf("%s ", mneu);
			if (count)
				printf("\n");
		}
		dis_16_bits = d16;
		if (dbprompt())
			return(0);
	}
}

sicmd()
{
	static char search_string[64];
	int	count;
	char	*ip, *string;

	skipsp();
	if (*cmdptr == '\0') {
		printf("missing search string\n");
		return(-1);
	}
	string = cmdptr;
	skipnsp();
	if (*cmdptr != '\0') {
		*cmdptr++ = '\0';
		skipsp();
	}
	if (*string != '$' || *(string+1) != '\0')
		strcpy(search_string,string);
	if (*cmdptr && getaddr(1)) {
		if (experr)
			return(-1);
		dot = addr.a_char;
	} 
	if (remref < 1)
		remref = 1024;
	for (count = remref; count--; ) {
		ip = dot;
		dot = (char *) dis_dot(ip);
		if (!match(search_string,mneu))
			continue;
		pntadr(ip);
		printf(": \t%s\n", mneu);
		return(0);
	}
	pntadr(dot);
	printf(": \tsearch failed!\n");
	return(-1);
}

Smcmd(type)
char type;
{
	unsigned long find_data;
	unsigned long match;
	int count;
	char *ip;

	skipsp();
	if (*cmdptr == '\0') {
		printf("missing search value\n");
		return(-1);
	}
	find_data = evalexp(0);
	if (experr)
		return(-1);
	if (getaddr(1)) {
		if (experr)
			return(-1);
	} else
		addr.a_char = dot;
	ip = addr.a_char;
	if (remref < 1)
		remref = 1024;
	for (count = remref; count--; ) {
		dot = ip;
		switch (type) {
		case 'l':
			match = *(unsigned long *)ip;
			ip += 4;
			break;
		case 's':
		case 'w':
			match = *(unsigned short *)ip;
			ip += 2;
			break;
		default:
			match = *(unsigned char *)ip;
			ip += 1;
			break;
		}
		if (match != find_data)
			continue;
		disp_mem(dot, type, 1);
		printf("\n");
		return(0);
	}
	pntadr(dot);
	printf(": \tsearch failed!\n");
	return(-1);
}

mlcmd()
{
	if (getaddr(1)) {
		if (experr)
			return(-1);
	} else
		addr.a_char = dot;

	if ( getvalue() == 0 ) {
		for(;;) {
			dot = addr.a_char;
			printf("%s: %X ", spntadr(addr.a_int), *addr.a_int);
			if(dbprompt()) {
				if (*cmdptr == '.')
					return(0);
				if (*cmdptr == '-')
					addr.a_int--;
				else if (*cmdptr == '*')
					addr.a_int = (int *)*addr.a_int;
				else {
					if(getvalue() == 0) return(0);
					*addr.a_int++ = (int) value;
				}
			} else
		   		addr.a_int++;
		}
	} else {
		*addr.a_int = (int) value;
	}
}

mscmd()
{
	if (getaddr(1)) {
		if (experr)
			return(-1);
	} else
		addr.a_char = dot;

	if ( getvalue() == 0 ) {
		for(;;) {
			dot = addr.a_char;
			printf("%s: %04X ", spntadr(addr.a_short), *addr.a_short);
			if(dbprompt()) {
				if (*cmdptr == '.')
					return(0);
				if (*cmdptr == '-')
					addr.a_short--;
				else {
					if(getvalue() == 0) return(0);
					*addr.a_short++ = (short) value;
				}
			} else
		   		addr.a_short++;
		}
	} else 
		*addr.a_short = (short) value;
}

mbcmd(type)
	char	type;
{
	if (getaddr(1)) {
		if (experr)
			return(-1);
	} else
		addr.a_char = dot;

	if ( getvalue() == 0 ) {
		for(;;) {
			dot = addr.a_char;
			printf("%s: %02X ", spntadr(addr.a_char), addr.a_uchar[0]);
			if(dbprompt()) {
				if (*cmdptr == '.')
					return(0);
				if (*cmdptr == '-')
					addr.a_char--;
				else {
					if(getvalue() == 0) return(0);
					*addr.a_char++ = (char) value;
				}
			} else
				addr.a_char++;
		}
	} else
		*addr.a_char++ = (char) value;
}

disp_mem(addr,type, symbolic)
unsigned char *addr;
char type;
{
	register unsigned char *p;
	register int i;

	if (symbolic) {
		pntadr(addr);
		printf("\n");
	} else {
		printf("%.6x: ", addr);
	}
	if (type == 'l') {
		for(p = addr, i = 0; i < 4; ++i, p += 4 ) 
			printf("%08x    ", *(long *) p);
	} else if (type == 's' || type == 'w') {
		for(p = addr, i = 0; i < 4; ++i, p += 4 ) 
			printf("%04x  %04x  ", *(ushort *) p,
						*(ushort *) (p+2));
	} else {
		for(p = addr, i = 0; i < 4; ++i, p += 4 ) 
			printf("%02x %02x %02x %02x ", 
				p[0], p[1], p[2], p[3]);
	}
	for(p = addr, i = 0; i < 16; ++i, ++p) {
		if (*p < ' ' || *p > 127)
			putchar('.');
		else
			putchar(*p);
	}
}

static
match(pattern,string)
register char *pattern, *string;
{
	while (*string) {
		if (mtch(pattern,string))
			return(1);
		string++;
	}
	return(0);
}

static
mtch(pattern,string)
register char *pattern, *string;
{
	while (*pattern) {
		if (*pattern != *string)
			return(0);
		pattern++;
		string++;
	}
	return(1);
}

bfill(p, c, size)
register char *p, c;
register int  size;
{
	while(size > 0) {
		*p++ = c;
		--size;
	}
}

wfill(p, c, size)
register short *p, c;
register int  size;
{
	while(size > 0) {
		*p++ = c;
		--size;
	}
}

lfill(p, c, size)
register int *p, c;
register int  size;
{
	while(size > 0) {
		*p++ = c;
		--size;
	}
}
