#include "debugger.h"

#define	NHISTORY	20
int	nhistory = 0;
int	firstcmd = 0;
char	history[NHISTORY] [MAXLINE];


#define	ETX		0x03
#define	DEL		0x7f

#define isalpha(c)	(((c)>='a'&&(c)<='z')||((c)>='A'&&(c)<='Z'))
#define	isdigit(c)	((c)>='0'&&(c)<='9')
#define isalnum(c)	(isalpha(c)||isdigit(c))

hicmd()
{
	int	i;

	for (i = 0; i < nhistory; i++)
		printf("%3d: %s\n",firstcmd+i+1,&history[i][0]);
	return(0);
}

add_history(cmd)
	char *cmd;
{
	int	i;

	cmdptr = cmd;
	skipsp();
	if (*cmdptr && !(*cmdptr == 'h' && *(cmdptr+1) == 'i')) {
		if (nhistory == NHISTORY) {
			firstcmd++;
			for (i = 0; i < NHISTORY-1; i++)
				strcpy(&history[i][0],&history[i+1][0]);
		} else
			nhistory++;
		strcpy(&history[nhistory-1][0],cmd);
	}
}

#define	to_dst(c)	{if(--length==0){printf(msg);return(-1);}*dst++=(c);}

int
expand_history(cmd)
	char *cmd;
{
	char		expansion[MAXLINE];
	int		edit = 0;
	int		expanded = 0;
	char		*src = cmd;
	char		*dst = expansion;
	int		length = MAXLINE-1;
	char		*s;
	char		*find_match();
	static char	msg[] = "expansion too long\n";

	while (*src) {
		if (*src == '\\') {
			src++;
			if (*src != '!' && *src != '~')
				to_dst('\\');
			to_dst(*src++);
		} else if (*src == '!' || *src == '~') {
			expanded++;
			if (*src++ == '~')
				edit++;
			if ((s=find_match(src)) == NULL)
				return(-1);
			while (*s)
				to_dst(*s++);
			if (*src == '!' || *src == '~')
				src++;
			else {
				while (*src && *src != ' ')
					src++;
			}
		} else
			to_dst(*src++);
	}

	*dst = 0;

	if (edit) {
		if (edit_cmd(expansion) == -1)
			return(-1);
		printf("\n");
	} else if (expanded)
		printf("%s\n",expansion);

	strcpy(cmd,expansion);
	return(0);
}

char *
find_match(pat)
	char *pat;
{
	int	i;
	char	*p = pat;
	char	*s;


	if (*p) {
		if (*p == '!' || *p == '~') {
			if (nhistory > 0)
				return(&history[nhistory-1] [0]);
		} else if (isdigit(*p)) {
			i = 0;
			while (isdigit(*p))
				i = (i * 10) + (*p++ - '0');
			i -= firstcmd;
			if (i > 0 && i <= nhistory)
				return(&history[i-1] [0]);
		} else if (isalpha(*p)) {
			for (i = nhistory; i; i--) {
				p = pat;
				s = &history[i-1][0];
				while (*p && *p == *s) {
					if (*p == ' ')
						break;
					 else if (!isalnum(*p))
						break;
					s++;
					p++;
				}
				if (*p == 0 || (*p == ' ' && *p == *s)) {
					return(&history[i-1][0]);
				}
			}
		}
	}

	printf("no match\n");
	return(NULL);
}

#ifdef	putc
#undef	putc
#endif
#ifdef	puts
#undef	puts
#endif

#define putc(p)		printf("%c",(p));
#define puts(p)		printf("%s",(p));
#define bs		printf("\b");
#define cr		printf("\r");
#define	saveundo	{strcpy(undoline,cmd);undocol=col;}
#define	noundo		{undocol=-1;}

int
edit_cmd(cmd)
	char *cmd;
{
	char	*p;
	char	*s;
	int	c;
	int	col;
	int 	length;
	int	i,j;
	int	num = 0;
	char	undoline[MAXLINE];
	int	undocol = -1;
	char	tmpline[MAXLINE];
	int	lastfind = 0;


	length = strlen(cmd);
	col = length - 1;
	p = cmd + length - 1;

	puts(cmd);
	bs;
	for (;;) {
		c = dbgetc();
		switch(c) {
		case 'q':
		case '\r':
			return(0);
		case ETX:
			printf("\n^C\n");
			return(-1);
		case DEL:
			printf("\ndel\n");
			return(-1);
		case 'x':
			saveundo;
			for (i = num == 0 ? 1 : num; i; i--) {
				if (length > 0) {
					delete(p,col,length);
					if (col > 0 && col == length-1) {
						bs;
						p--;
						col--;
					}
					length--;
				}
			}
			num = 0;
			break;
		case 'D':
			saveundo;
			*p = 0;
			for (i = length - col; i; i--)
				putc(' ');
			cr;
			puts(cmd);
			bs;
			length = strlen(cmd);
			col = length - 1;
			p = cmd + length - 1;
			num = 0;
			break;
		case 'i':
			saveundo;
			i = 0;
			for (;;) {
				c = dbgetc();
				if (c == '\b') {
					if (i > 0) {
						i--;
						bs;
						p--;
						col--;
						delete(p,col,length);
						length--;
					}
				} else if (c >= ' ') {
					if (insert(p,col,length)) {
						i++;
						putc(c);
						*p++ = c;
						col++;
						length++;
					}
				} else
					break;
			}

			if (p != cmd) {
				p--;
				col--;
				bs;
			}
			num = 0;
			break;
		case 'A':
			puts(p);
			bs;
			p = cmd + length - 1;
			col = length - 1;
		case 'a':
			saveundo;
			i = 0;
			putc(*p++);
			col++;
			for (;;) {
				c = dbgetc();
				if (c == '\b') {
					if (i > 0) {
						i--;
						bs;
						p--;
						col--;
						delete(p,col,length);
						length--;
					}
				} else if (c >= ' ') {
					if (*p == 0) {
						putc(c);
						i++;
						*p++ = c;
						*p = 0;
						col++;
						length++;
					} else {
						if (insert(p,col,length)) {
							i++;
							putc(c);
							*p++ = c;
							col++;
							length++;
						}
					}
				} else
					break;
			}

			p--;
			col--;
			bs;
			num = 0;
			break;
		case '\033':
			num = 0;
			noundo;
			break;
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			noundo;
			num = (num * 10) + (c - '0');
			break;
		case '0':
			noundo;
			if (num == 0) {
				cr;
				p = cmd;
				col = 0;
			} else
				num *= 10;
			break;
		case '$':
			noundo;
			puts(p);
			bs;
			p = cmd + length - 1;
			col = length - 1;
			break;
		case 'h':
		case '\b':
			noundo;
			for (i = num == 0 ? 1 : num; i; i--) {
				if (col > 0) {
					bs;
					p--;
					col--;
				}
			}
			num = 0;
			break;
		case 'l':
			noundo;
			for (i = num == 0 ? 1 : num; i; i--) {
				if (col < length-1) {
					putc(*p++);
					col++;
				}
			}	
			num = 0;
			break;
		case 'r':
			saveundo;
			c = dbgetc();
			if (c >= ' ' && c < 0x7f) {
				*p = c;
				putc(c);
				bs;
			}
			num = 0;
			break;
		case ';':
			noundo;
			if (lastfind != 0) {
				c = (lastfind > 0 ? lastfind : -lastfind);
				if (lastfind > 0)
					goto fndfwd;
				else
					goto fndback;
			}
			break;
		case 'f':
			noundo;
			c = dbgetc();
			lastfind = c;
fndfwd:
			if (c < ' ' || c > 0x7f) {
				num = 0;
				break;
			}
			for (i = num == 0 ? 1 : num; i; i--) {
				s = p;
				if (*s++) {
					while (*s && *s != c)
						s++;
					if (*s) {
						while (p != s) {
							putc(*p++);
							col++;
						}
					}
				}
			}
			num = 0;
			break;
		case 'F':
			noundo;
			c = dbgetc();
			lastfind = -c;
fndback:
			if (c < ' ' || c > 0x7f) {
				num = 0;
				break;
			}
			for (i = num == 0 ? 1 : num; i; i--) {
				s = p - 1;
				if (col > 0) {
					j = col + 1;
					while (j-- && *s != c)
						s--;
					if (j > 0) {
						cr;
						p = cmd;
						col = 0;
						while (p != s) {
							putc(*p++);
							col++;
						}
					}
				}
			}
			num = 0;
			break;
		case 'u':
			if (undocol != -1) {
				strcpy(tmpline,cmd);
				i = col;
				strcpy(cmd,undoline);
				col = undocol;
				strcpy(undoline,tmpline);
				undocol = i;

				cr;
				puts(cmd);
				if ((i=strlen(undoline)-strlen(cmd)) > 0) {
					while (i--)
						putc(' ');
				}
				cr;

				p = cmd;
				for (i = col; i; i--)
					putc(*p++);
				length = strlen(cmd);
			}
			num = 0;
			break;
		default:
			noundo;
			num = 0;
			putc('\007');
			break;
		}
	}
}

int
insert(p,col,length)
	char	*p;
	int	col;
	int	length;
{
	int i = 0;

	if (length >= MAXLINE-2)
		return(0);
	
	while (*p) {
		i++;
		putc(*p++);
	}

	putc(*(p-1));
	bs;

	*(p+1) = 0;
	while (i--) {
		*p = *(p-1);
		putc(*p--);
		bs;
		bs;
	}

	return(1);
}

delete(p,col,length)
	char	*p;
	int	col;
	int	length;
{
	int i = 0;

	while (*p && col++ < length) {
		*p = *(p+1);
		putc(*p++);
		i++;
	}

	*p = 0;
	putc(' ');

	while (i--)
		bs;
}
