#ifdef notdef
/*
 * Print out commenly desired structures.
 */
#include "sys/types.h"
#include "sys/reg.h"
#include "sys/param.h"
#include "sys/mbuf.h"
#include "sys/socketvar.h"
#include "debugger.h"

#include "sys/socket.h"
#include "sys/unpcb.h"
#include "sys/un.h"

#include "net/if.h"
#include "net/route.h"
#include "netinet/in.h"
#include "netinet/if_ether.h"
#include "netinet/in_pcb.h"

static 	char	*mbufnames[] = { "FREE", "DATA", "HEADER", "SOCKET", "PCB",
			  	 "RTABLE", "HTABLE", "ATABLE", "SONAME",
			  	 "ZOMBIE", "SOOPTS", "FTABLE", "RIGHTS", 
				 "IFADDR" };

prmbuf()
{
	register i;
	register char *type;
	register struct mbuf *m;
	register count;

	if (getwaddr() == 0 || experr) return(-1);
	m = (struct mbuf *)addr.a_int;
	if (m->m_type >= MT_IFADDR) {
		printf("MBUF 0x%x: bad type 0x%x\n", m, m->m_type);
		return;
	}
	printf("type: %s len: %x off: %x data: %x next: %x act: %x\n",
		mbufnames[m->m_type], m->m_len, m->m_off, mtod(m, long),
		m->m_next, m->m_act);
	for (count = 0, i = m->m_off; i < (m->m_off + m->m_len) && count < 256;
	    i += 16, count += 16) {
		disp_mem((unsigned char *)m + i, 'b', 0);
		printf("\n");
	}
}

#define IFBITS "\20\10noarp\07running\06notrailers\05ptp\04lbk\03debug\02broadcast\01up"

static 	char	
ifheading[] = "  ADDR   NAME  MTU ADDRLIST   IPKTS IERRS   OPKTS OERRS COLL FLAGS\n";

static
prif(ifp)
	struct ifnet *ifp;
{
	char nbuf[8];

	sprintf(nbuf,"%s%d", ifp->if_name, ifp->if_unit);
	printf("%08x %-4s %04x %08x %7d %5d %7d %5d %4d %b\n",
	       ifp, nbuf,
	       ifp->if_mtu, ifp->if_addrlist,
	       ifp->if_ipackets, ifp->if_ierrors,
	       ifp->if_opackets, ifp->if_oerrors,
	       ifp->if_collisions, ifp->if_flags,
	       IFBITS);
}

static
prsockaddr(sa)
	struct sockaddr *sa;
{
	struct sockaddr_in *sin;
	uchar *cp;
	uint addr;
	int n;

	switch(sa->sa_family){
	case AF_UNSPEC:
		break;
	case AF_INET:
		sin = (struct sockaddr_in *)sa;
		addr = ntohl(sin->sin_addr.s_addr);
		printf("%02x.%02x.%02x.%02x",
		       ((addr >> 24) & 0xff),
		       ((addr >> 16) & 0xff),
		       ((addr >> 8) & 0xff),
		       ((addr) & 0xff));
		break;
	default:
		for (cp = (u_char *)sa +
		     sizeof(struct sockaddr) - 1;
		     cp >= (u_char *)sa->sa_data; --cp)
			if (*cp != 0)
				break;
		n = cp - (u_char *)sa->sa_data + 1;
		cp = (u_char *)sa->sa_data;
		if (n <= 6)
			while (--n)
				printf("%02x.", *cp++);
		else
			while (--n)
				printf("%02x ", *cp++);
		printf("%02x", *cp);
		break;
	}
}

static
prfullifnet(ifp)
	struct ifnet *ifp;
{
	struct ifaddr *ifa;

	printf("%s%d:\n", ifp->if_name, ifp->if_unit);
	printf("   MTU  TIMER METRIC   FLAGS\n");
	printf("   %04x  %4x   %4x    %b\n",
	       ifp->if_mtu, ifp->if_timer,
	       ifp->if_metric, ifp->if_flags, IFBITS);
	printf("   PKTS IN   ERR      PKTS OUT   ERR  COLLISIONS\n");
	printf("   %7d %5d       %7d %5d    %6d\n",
	       ifp->if_ipackets, ifp->if_ierrors, ifp->if_opackets,
	       ifp->if_oerrors, ifp->if_collisions);
	ifa = ifp->if_addrlist;
	if (ifa) {
		printf("   ADDRESS:\n");
		printf("       FAMILY  INTERFACE   BCAST/DEST\n");
	}
	while (ifa) {
		switch(ifa->ifa_addr.sa_family) {
		case AF_UNSPEC:
			printf("     AF_UNSPEC ");
			break;
		case AF_INET:
			printf("       AF_INET ");
			break;
		default:
			printf("       AF%-5d ",
			       ifa->ifa_addr.sa_family);
			break;
		}
		prsockaddr(&ifa->ifa_addr);
		printf(" ");
		prsockaddr(&ifa->ifa_broadaddr);
		printf("\n");
		ifa = ifa->ifa_next;
	}
	printf("   SEND QUEUE:\n");
	printf("      HEAD     TAIL    LEN   MAXLEN   DROPS  LOCK BUSY\n");
	printf("  %8x %8x %6d   %6d  %6d    %2x %4d\n",
	       ifp->if_snd.ifq_head, ifp->if_snd.ifq_tail,
	       ifp->if_snd.ifq_len, ifp->if_snd.ifq_maxlen,
	       ifp->if_snd.ifq_drops, ifp->if_snd.ifq_lock.l_spinbyte,
	       ifp->if_snd.ifq_busy);
	printf("NEXT IFNET = %08x\n", ifp->if_next);
}

prifnet()
{
	register struct ifnet *ifp;
	char *p;
	register int	j;

	skipsp();
	p = cmdptr;
	if (*p == '\0') {
		printf(ifheading);
		for (j = 0, ifp = ifnet; ifp; ifp = ifp->if_next) {
			if (more_abort)
				return(0);
			prif(ifp);
			if ((++j % 20) == 0 && nomore())
				break;
		}
		printf("Number of interfaces: %d\n", j );
	} else {
		ifp = ifnet;
		while (ifp) {
			char name[10];
			sprintf(name,"%s%d", ifp->if_name, ifp->if_unit);
			if (strncmp(p, name, strlen(name)+1) == 0)
				break;
			ifp = ifp->if_next;
		}
		if (ifp)
			prfullifnet(ifp);
		else
			if(getaddr(1)) {
				if (experr)
					return(-1);
				prfullifnet((struct ifnet *) addr.a_int);
			}
	}
	return(0);
}

prso()
{
	register struct socket *s;

	if(getwaddr() == 0 || experr) return(-1);
	s = (struct socket *)addr.a_int;
printf(" so_type:    %04x        ",s->so_type);
printf(" so_options: %04x\n",s->so_options);
printf(" so_linger:  %04x        ",s->so_linger);
printf(" so_state:   %04x\n",s->so_state);
printf(" so_pcb:     %8x    ",s->so_pcb);
printf("*so_proto:   %x\n",s->so_proto);
printf("*so_head:    %x\n",s->so_head);
printf("*so_q0:      %8x    ",s->so_q0);
printf(" so_q0len:   %4x\n",s->so_q0len);
printf("*so_q:       %8x    ",s->so_q);
printf(" so_qlen:    %4x\n",s->so_qlen);
printf(" so_qlimit:  %4x\n",s->so_qlimit);
printf(" struct so_rcv             struct so_snd\n");
printf("     sb_cc:    %04x            sb_cc:    %04x\n",s->so_rcv.sb_cc,s->so_snd.sb_cc);
printf("     sb_hiwat: %04x            sb_hiwat: %04x\n",s->so_rcv.sb_hiwat,s->so_snd.sb_hiwat);
printf("     sb_mbcnt: %04x            sb_mbcnt: %04x\n",s->so_rcv.sb_mbcnt,s->so_snd.sb_mbcnt);
printf("     sb_mbmax: %04x            sb_mbmax: %04x\n",s->so_rcv.sb_mbmax,s->so_snd.sb_mbmax);
printf("     sb_lowat: %04x            sb_lowat: %04x\n",s->so_rcv.sb_lowat,s->so_snd.sb_lowat);
printf("     sb_timeo: %04x            sb_timeo: %04x\n",s->so_rcv.sb_timeo,s->so_snd.sb_timeo);
printf("    *sb_mb:    %08x       *sb_mb:    %08x\n",s->so_rcv.sb_mb,s->so_snd.sb_mb);
printf("    *sb_sel:   %08x       *sb_sel:   %08x\n",s->so_rcv.sb_sel,s->so_snd.sb_sel);
printf("     sb_flags: %04x            sb_flags: %04x\n",s->so_rcv.sb_flags,s->so_snd.sb_flags);
printf(" ---------- \n");
printf(" so_timeo: %04x  ",s->so_timeo);
printf("so_error: %04x  ",s->so_error);
printf("so_oobmark: %04x  ",s->so_oobmark);
printf("so_pgrp: %04x\n",s->so_pgrp);
}

prinetaddr(addr, port)
	long addr;
	short port;
{
	if (addr == INADDR_ANY)
		printf("*");
	else {
		printf("%02x.%02x.%02x.%02x",
		       ((addr >> 24) & 0xff),
		       ((addr >> 16) & 0xff),
		       ((addr >> 8) & 0xff),
		       ((addr) & 0xff));
	}
	printf(":");
	if (port == 0)
		printf("*");
	else
		printf("%d", port);
} 

prinpcb()
{
	register struct inpcb *pin;
	if(getwaddr() == 0 || experr) return(-1);
	pin = (struct inpcb *)addr.a_int;
printf("inpcb: %x\n",pin);
printf("*inp_next:    %x - pointer to other pcb's\n",pin->inp_next);
printf("*inp_prev:    %x - pointer to other pcb's\n",pin->inp_prev);
printf("*inp_head:    %x - back pointer to chain head\n",pin->inp_head);
printf(" inp_faddr:   ");
prinetaddr(ntohl(pin->inp_faddr.s_addr), ntohs(pin->inp_fport));
printf(" inp_laddr:   ");
prinetaddr(ntohl(pin->inp_laddr.s_addr), ntohs(pin->inp_lport));
printf("\n");
printf("*inp_socket:  %x - back pointer to socket\n",pin->inp_socket);
printf(" inp_ppcb:    %x - pointer to per-protocol pcb\n",pin->inp_ppcb);
printf("struct route  inp_route - placeholder for routing entry\n");
printf("     *ro_rt   %x\n",pin->inp_route.ro_rt);
printf("      ro_dst  %x (%x,%x,%x...+11),\n",pin->inp_route.ro_dst.sa_family,
									      	  pin->inp_route.ro_dst.sa_data[0],
										      pin->inp_route.ro_dst.sa_data[1],
										      pin->inp_route.ro_dst.sa_data[2]);
printf("*inp_options: %x - IP options\n",pin->inp_options);
}

prunpcb()
{
	register struct unpcb *unp;

	if(getwaddr() == 0 || experr) return(-1);
	unp = (struct unpcb *)addr.a_int;
printf("unpcb: %x\n",unp); 
printf("*unp_socket:  %x  - pointer back to socket\n",unp->unp_socket);
printf("*unp_inode:   %x  - if associated with file\n",unp->unp_inode);
printf(" unp_ino:     %x  - fake inode number\n",unp->unp_ino&0xffff);
printf("*unp_conn:    %x  - control block of connected socket\n",unp->unp_conn);
printf("*unp_refs:    %x  - referencing socket linked list\n",unp->unp_refs);
printf("*unp_nextref: %x  - link in unp_refs list\n",unp->unp_nextref);
printf(" unp_cc:      %x  - copy of rcv.sb_cc\n",unp->unp_cc);
printf(" unp_mbcnt:   %x  - copy of rcv.sb_mbcnt\n",unp->unp_mbcnt);
printf("*unp_addr:    %x  - bound address of socket\n",unp->unp_addr);
if (unp->unp_addr)
	printf(" unp_addr:    %s\n",
	       mtod(unp->unp_addr, struct sockaddr_un *)->sun_path);
}
#endif /* TCP */
