
#include "dis.h"

#define  ISP	0
#define  DSP	1


/*
 *	compoff (lng, temp)
 *
 *	This routine will compute the location to which control is to be
 *	transferred.  'lng' is the number indicating the jump amount
 *	(already in proper form, meaning masked and negated if necessary)
 *	and 'temp' is a character array which already has the actual
 *	jump amount.  The result computed here will go at the end of 'temp'.
 *	(This is a great routine for people that don't like to compute in
 *	hex arithmetic.)
 */

compoff(lng, temp)
long	lng;
char	*temp;
{
	extern	unsigned char	*loc;

	sprintf(temp,"%s <%s>",temp,spntadr(loc+lng));
}
/*
 *	convert (num, temp, flag)
 *
 *	Convert the passed number to hex
 *	leaving the result in the supplied string array.
 *	If  LEAD  is specified, precede the number with '0x' to
 *	indicate the base (used for information going to the mnemonic
 *	printout).  NOLEAD  will be used for all other printing (for
 *	printing the offset, object code, and the second byte in two
 *	byte immediates, displacements, etc.) and will assure that
 *	there are leading zeros.
 */

convert(num,temp,flag)
	int	num;
	char	temp[];
	int	flag;
{
	if (flag == NOLEAD)
		sprintf(temp,"%04x",num);
	if (flag == LEAD)
		strcpy(temp,spntadr(num));
	if (flag == NOLEADSHORT)
		sprintf(temp,"%02x",num);
}

/*
 *	getbyte ()
 *
 *	read a byte, mask it, then return the result in 'curbyte'.
 *	The getting of all single bytes is done here.  The 'getbyte[s]'
 *	routines are the only place where the global variable 'loc'
 *	is incremented.
 */
int
getbyte()
{
	extern	unsigned char	*loc;		/* from _extn.c */
	extern	unsigned short curbyte;	/* from _extn.c */
	char	temp[NCPS+1];

	curbyte = *loc++ & 0377;
	convert(curbyte, temp, NOLEADSHORT);
}


/*
 *	lookbyte ()
 *
 *	read a byte, mask it, then return the result in 'curbyte'.
 *	loc is incremented.
 */

lookbyte()
{
	extern	unsigned char  *loc;		/* from _extn.c */
	extern	unsigned short curbyte;	/* from _extn.c */

	curbyte = *loc++;
}
