/*
* Nand Flash Status Signals
*/

#define	FNAND_READY0     0x02
#define	FNAND_READY1     0x01
#define	FNAND_READYMASK  FNAND_READY0 + FNAND_READY1

/*
; Flash Commands
*/

#define	FNAND_CMD_READ_MODE1	0x0000
#define	FNAND_CMD_READ_MODE2    0x5050
#define	FNAND_CMD_WRITE         0x8080
#define	FNAND_CMD_STATUS_READ   0x7070
#define	FNAND_CMD_ID_READ       0x9090
#define	FNAND_CMD_AUTO_PROGRAM  0x1010
#define	FNAND_CMD_ERASE    	0x6060
#define	FNAND_CMD_ERASE2   	0xd0d0
#define	FNAND_CMD_SUSPEND       0xb0b0
#define	FNAND_CMD_RESUME        0xd0d0
#define	FNAND_CMD_RESET         0xffff


/*
; Flash Status Bits
; (The write protect bit is active low)
*/

#define	FNAND_STS_FAIL           0x0101
#define	FNAND_STS_SUSPEND        0x2020
#define	FNAND_STS_READY          0x4040
#define	FNAND_STS_WRITE_PROTECT  0x8080

/*
; Flash Sizes
*/
#define	FNAND_PAGE_SIZE          512
#define	FNAND_RDNT_SIZE          16
#define	FNAND_PAGES_PER_BLOCK    16
#define	FNAND_BLOCK_SIZE         (FNAND_PAGE_SIZE * FNAND_PAGES_PER_BLOCK)

#define	FNAND_BLOCKS             512
#define	FNAND_PAGES              (FNAND_BLOCKS * FNAND_PAGES_PER_BLOCK)

#define	FNAND_CHECKSUM		0xAA55
