#ifdef	WYSE
#define	CS_IOBASE 	0x0300
#define	CS_INTRQ	INTRQ0
#define	CS_IRQ		10
#else
#define	CS_IOBASE 	0x02A0
#define	CS_INTRQ	INTRQ3
#define	CS_IRQ		5
#endif

#define	OUTW(port, val)	outw(val, port)
#define	INW(port)	inw(port)

#define SelfCTL		0x114
#define SelfST		0x136

#define LineCTL		0x112
#define LineST		0x134
#define TestCTL		0x118

#define IObase		0x20
#define IRQnum		0x22
#define EEPROMcmd	0x40 
#define EEPROMdata	0x42 

#define RxCFG		0x102
#define RxCTL		0x104
#define RxEvent		0x124
#define RxMissCount	0x130
#define TxCFG		0x106
#define TxCMD		0x108
#define TxEvent		0x128
#define TxColCount	0x132
#define BusCTL		0x116
#define BusST           0x138
#define BufCFG          0x10A
#define RxStatus	0x8400
#define TxFrame		0x8A00
#define	AutoInc		0x8000	// auto increment; or-ed with address

#define ChipEA0		0x158
#define ChipEA2		0x15A
#define ChipEA4		0x15C

// 	EEPROM command
#define EEread		0x0200	// read mask
#define EEwrite		0x0100
#define EEerase		0x0300
#define EEenable	0x0030
#define EEdisable	0x0000

#define	EEPROM_SIZE	64	// 64 words

#define PortData		(CS_IOBASE + 0x00)
#define PortTxCMD		(CS_IOBASE + 0x04)
#define	PortTxLength		(CS_IOBASE + 0x06)
#define	PortISQ			(CS_IOBASE + 0x08)
#define	PortPacketPagePtr	(CS_IOBASE + 0x0A)
#define	PortPacketPageData	(CS_IOBASE + 0x0C)

#define RxEventReg 	0x04
#define TxEventReg 	0x08
#define BufEventReg 	0x0C
#define RxMissEventReg 	0x10
#define TxCOLEventReg 	0x12

#define SerTxON      	0x0080
#define SerRxON 	0x0040

#define	RxOK      	0x0100
#define	Rdy4TxNow 	0x0100

#define	INTRQ0		0x0000		/* IRQ 10 */
#define	INTRQ3		0x0003		/* IRQ 5  */

#define NSS_INITD		0x0080
#define NSS_SIBUSY		0x0100
#define NSS_EEPROMEXIST		0x0200
#define NSS_EEPROMOK		0x0400
#define NSS_EESIZE		0x1000


