#ifdef	__KERNEL__
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/stat.h>
#include <linux/string.h>
#include <linux/locks.h>

#include <linux/flash_fs.h>
#include <linux/flash.h>

#include <asm/segment.h>
#else
#include "system.h"
#include "errno.h"
#include "flash_fs.h"
#include "flash.h"
#endif

struct ffs_buf *
ffs_getblk(struct inode *inode, int offset, int alloc)
{
	int	pageno, sectno;
	struct	flash_imap	*ip;

	/* index page, directory pages are fixed pagesize */
	sectno = SECTNO(offset);
	ip = inode->i_ffs_ip;
	ASSERT(ip);
	if (sectno >= ip->mapsize) {
		if (alloc <= 0)
			return(0);
		flash_imap_expand(ip, sectno);
		if (sectno >= ip->mapsize)
			return(0);
	}
	
	if ((pageno = ip->map[sectno]) == 0) {
		if (alloc <= 0)
			return(0);
		return(ffs_balloc(inode, sectno));
	}

#ifdef	__KERNEL__
	if (alloc < 0)
		return(ffs_bpage(inode, sectno, pageno));
#endif
	if (alloc == 0)
		return(ffs_bread(inode, sectno, pageno));
	else
		return(ffs_bremap(inode, sectno, pageno));
}
