/* zutil.c -- target dependent utility functions for the compression library
 * Copyright (C) 1995-1996 Jean-loup Gailly.
 * For conditions of distribution and use, see copyright notice in zlib.h 
 */

/* $Id: zutil.c,v 1.1 1999/01/12 02:40:27 adam Exp $ */

#include <stdio.h>

#include "zutil.h"

struct internal_state      {int dummy;}; /* for buggy compilers */

#ifndef STDC
extern void exit OF((int));
#endif

const char *z_errmsg[10] = {
"need dictionary",     /* Z_NEED_DICT       2  */
"stream end",          /* Z_STREAM_END      1  */
"",                    /* Z_OK              0  */
"file error",          /* Z_ERRNO         (-1) */
"stream error",        /* Z_STREAM_ERROR  (-2) */
"data error",          /* Z_DATA_ERROR    (-3) */
"insufficient memory", /* Z_MEM_ERROR     (-4) */
"buffer error",        /* Z_BUF_ERROR     (-5) */
"incompatible version",/* Z_VERSION_ERROR (-6) */
""};


const char *zlibVersion()
{
    return ZLIB_VERSION;
}

#ifdef DEBUG
void z_error (m)
    char *m;
{
    fprintf(stderr, "%s\n", m);
    exit(1);
}
#endif

char	zmbuf[0x48000];
int	zmptr = 0;

voidpf
zminit(void)
{
	zmptr = 0;
}
	
voidpf 
zcalloc(voidpf opaque, unsigned items, unsigned size)
{
	char	*retval;
	int	alloc_size = items * size;

	alloc_size &= 0xFFFFFFFC;
	alloc_size += 4;
	if ((zmptr + alloc_size) <= sizeof(zmbuf)) {
		retval = zmbuf + zmptr;
		// memset(retval, 0, alloc_size);
		zmptr += alloc_size;
		return((voidpf) retval);
	} 
	return(0);
}

void  
zcfree(voidpf opaque, voidpf ptr)
{
	return;
}
