#if !defined(__FONT_H_)
#define __FONT_H_

#include <asm/processor.h>

typedef struct font {
    	const unsigned char *fnt_bits;	/* fixed font bitmap */
    	char		fnt_width;	/* width (average for proportional) */
    	char		fnt_height;	/* font height */
    	char		fnt_chrsize;	/* size of a character in bytes */
    	unsigned char	fnt_minchar;	/* lowest character code in font */
    	unsigned short	fnt_maxchar;	/* highest character code in font */
} Font, *pFont;

#define	FONT_HEIGHT	16
#define	FONT_WIDTH	8

#ifdef	__KERNEL__
#define	VIDEO_WIDTH	video_width
#define	VIDEO_HEIGHT	video_height
extern	int		video_width, video_height;
#else
#define VIDEO_WIDTH	640
#define VIDEO_HEIGHT	480
#endif

#define	BYTES_PER_PIXEL	1

#define	LINE_WIDTH	(VIDEO_WIDTH / FONT_WIDTH)
#define	LINE_HEIGHT	(VIDEO_HEIGHT / FONT_HEIGHT)
#define	LINE_SIZE	(VIDEO_WIDTH * FONT_HEIGHT * BYTES_PER_PIXEL)

#define	VBASE_MARS	(36 * 1024 *1024)
#define	VBASE_LEO	(0x40800000)
#define VBASE		(WYSE_MARS ? VBASE_MARS : VBASE_LEO)

#ifdef	MARS_MODE5
#define	COLOR_SHIFT	3
#else
#define	COLOR_SHIFT	0
#endif
#endif /* !defined(__FONT_H_) */
