/* Appearance will be as follows:
 *	Background: DKGREY
 *	Image background: LTGREY.  A multiple of 10 character columns but not
 *		the full width (+ 4, 2 per side).  6 Vertical character
 *		positions.
 *	Image: Provided color as a calculated percentage. 4 high, a multiple of
 *		10 character columns wide.
 */
#include "colors.h"
#include "font.h"

#define	BAR_WIDE	(((VIDEO_WIDTH/FONT_WIDTH-1)/10)*10)	/* In chars */
#define BAR_HIGH	2				/* In chars */

unsigned char *vbase = (unsigned char*) 0;
int	startbar_item;
int	mkey_pressed = 1;

#ifdef	EPROM
#define	NITEMS	13
#define	COLOR	BLUE
#include "sys/debug.h"
#else
#define	NITEMS	23
#define	COLOR	DKYELLOW
#include "linux/debug.h"
#endif

int	startbar_nitems = NITEMS;

void
init_vbase(void) {
	if (vbase == 0) vbase = VBASE;
}

void
draw_rectangle(unsigned int sx, int sy, unsigned int ex, int ey, char pixval)
{
    	int 	xlength;
    	unsigned char *memptr;

#ifdef	MARS_MODE5
	outGR(0, pixval);
	pixval = 0;
#endif
    	xlength = (ex - sx + 1) >> COLOR_SHIFT;
    	memptr = vbase + (((sy * VIDEO_WIDTH) + sx) >> COLOR_SHIFT);
    	while (sy++ <= ey) {
    		memset(memptr, pixval, xlength);
		memptr += VIDEO_WIDTH >> COLOR_SHIFT;
    	}
#ifdef	MARS_MODE5
	outGR(0, WHITE);
#endif
}

void
startbar(char *msg, int a, int b, int c)
{
    	int sx, ex, sy, ey;
    	int msgsx, msgsy;
    	int psx, pex, psy, pey;
    	static int first_time = 1;
    	char buf[128];

    	if (++startbar_item > startbar_nitems)
		startbar_item = startbar_nitems;

    	/* Enter graphics mode */
    	/* Grey border around status bar */
    	sx = ((VIDEO_WIDTH/FONT_WIDTH - BAR_WIDE - 1) / 2) - 1;
    	ex = ((VIDEO_WIDTH/FONT_WIDTH + BAR_WIDE + 1) / 2) + 2;
    	sy = VIDEO_HEIGHT/FONT_HEIGHT - BAR_HIGH - 2;     /* 1 char above     */
    	ey = VIDEO_HEIGHT/FONT_HEIGHT - 1; /* 1 char below     */
    	psx = sx * FONT_WIDTH;
    	pex = ex * FONT_WIDTH - 1;
	psy = sy * FONT_HEIGHT;
	pey = ey * FONT_HEIGHT - 1;
	msgsx = sx;
	msgsy = sy;

	/* Actual status bar */
	sx += 2;
	ex -= 2;
	sy++;
	ey--;
	psx = sx * FONT_WIDTH;
	pex = ex * FONT_WIDTH - 1;
	psy = sy * FONT_HEIGHT;
	pey = ey * FONT_HEIGHT - 1;
	if (first_time) {
		first_time = 0;
		text_init();

#ifdef	EPROM
		draw_rectangle(psx, psy, pex, pey, WHITE);
		text_out(ey, sx, "0     10     20     30     40     50     60     70     80     90   100");
#endif
    	}
#ifdef	__KERNEL__
	wmode5();
#endif

	if (mkey_pressed) {
		/* Draw the rectangle and spit out the text string */
		sprintf(buf, "%*.*s", BAR_WIDE, BAR_WIDE, " ");
		text_out(sy-1, sx, buf);
		sprintf(buf, msg, a, b, c);
		buf[BAR_WIDE] = 0;
		text_out(sy-1, sx, buf);
	}

	pex = (pex - psx) * startbar_item / startbar_nitems;
	pex += psx;	/* restore origin */
	draw_rectangle(psx, psy, pex, pey, COLOR);
}

#ifdef	EPROM
void
startmsg(char *msg, int a, int b, int c)
{
	pause(2);
	startbar(msg, a, b, c);
	pause(2);
}
#endif
